searchNodes=[{"doc":"The biggest ambiguity between datetime formats is whether it's ymd (year month day), mdy (month day year), or dmy (day month year); this is resolved by checking if there are slashes or dashes. If slashes, then it will try dmy first. All other cases will use the international format ymd . Sometimes, if the conditions are right, it can even parse dmy with dashes if the month is a vocal month (eg, &quot;Jan&quot; ). If the string consists of only numbers, then we will try two other parsers depending on the number of digits: Epoch or Serial . Otherwise, we'll try the tokenizer. If the string is 10-11 digits with optional precision, then we'll try to parse it as a Unix Epoch timestamp. If the string is 1-5 digits with optional precision, then we'll try to parse it as a Serial timestamp (spreadsheet time) treating 1899-12-31 as 1. This will cause Excel-produced dates from 1900-01-01 until 1900-03-01 to be incorrect, as they really are. digits parser range notes 1-5 Serial low = 1900-01-01 , high = 2173-10-15 . Negative numbers go to 1626-03-17 Floats indicate time. Integers do not. 6-9 Tokenizer any This allows for &quot;20190429&quot; to be parsed as 2019-04-29 10-11 Epoch low = -1100-02-15 14:13:21 , high = 5138-11-16 09:46:39 If padded with 0s, then it can capture entire range. else Tokenizer any Required reading Elixir DateTime docs Elixir NaiveDateTime docs Elixir Date docs Elixir Time docs Elixir Calendar docs Examples iex&gt; DateTimeParser . parse ( &quot;19 September 2018 08:15:22 AM&quot; ) { :ok , ~N[2018-09-19 08:15:22] } iex&gt; DateTimeParser . parse_datetime ( &quot;19 September 2018 08:15:22 AM&quot; ) { :ok , ~N[2018-09-19 08:15:22] } iex&gt; DateTimeParser . parse_datetime ( &quot;2034-01-13&quot; , assume_time : true ) { :ok , ~N[2034-01-13 00:00:00] } iex&gt; DateTimeParser . parse_datetime ( &quot;2034-01-13&quot; , assume_time : ~T[06:00:00] ) { :ok , ~N[2034-01-13 06:00:00] } iex&gt; DateTimeParser . parse ( &quot;invalid date 10:30pm&quot; ) { :ok , ~T[22:30:00] } iex&gt; DateTimeParser . parse ( &quot;2019-03-11T99:99:99&quot; ) { :ok , ~D[2019-03-11] } iex&gt; DateTimeParser . parse ( &quot;2019-03-11T10:30:00pm UNK&quot; ) { :ok , ~N[2019-03-11T22:30:00] } iex&gt; DateTimeParser . parse ( &quot;2019-03-11T22:30:00.234+00:00&quot; ) { :ok , DateTime . from_naive! ( ~N[2019-03-11T22:30:00.234Z] , &quot;Etc/UTC&quot; ) } # `~U[2019-03-11T22:30:00.234Z]` in Elixir 1.9+ iex&gt; DateTimeParser . parse_date ( &quot;2034-01-13&quot; ) { :ok , ~D[2034-01-13] } iex&gt; DateTimeParser . parse_date ( &quot;01/01/2017&quot; ) { :ok , ~D[2017-01-01] } iex&gt; DateTimeParser . parse_datetime ( &quot;1564154204&quot; ) { :ok , DateTime . from_naive! ( ~N[2019-07-26T15:16:44Z] , &quot;Etc/UTC&quot; ) } # `~U[2019-07-26T15:16:44Z]` in Elixir 1.9+ iex&gt; DateTimeParser . parse_datetime ( &quot;41261.6013888889&quot; ) { :ok , ~N[2012-12-18T14:26:00] } iex&gt; DateTimeParser . parse_date ( &quot;44262&quot; ) { :ok , ~D[2021-03-07] } # This is a serial number date, commonly found in spreadsheets, eg: `=VALUE(&quot;03/07/2021&quot;)` iex&gt; DateTimeParser . parse_datetime ( &quot;1/1/18 3:24 PM&quot; ) { :ok , ~N[2018-01-01T15:24:00] } iex&gt; DateTimeParser . parse_datetime ( &quot;1/1/18 3:24 PM&quot; , assume_utc : true ) { :ok , DateTime . from_naive! ( ~N[2018-01-01T15:24:00Z] , &quot;Etc/UTC&quot; ) } # `~U[2018-01-01T15:24:00Z]` in Elixir 1.9+ iex&gt; DateTimeParser . parse_datetime ( ~s|&quot;Mar 28, 2018 7:39:53 AM PDT&quot;| , to_utc : true ) { :ok , DateTime . from_naive! ( ~N[2018-03-28T14:39:53Z] , &quot;Etc/UTC&quot; ) } iex&gt; { :ok , datetime } = DateTimeParser . parse_datetime ( ~s|&quot;Mar 1, 2018 7:39:53 AM PST&quot;| ) iex&gt; datetime # DateTime &lt; 2018 - 03 - 01 07 : 39 : 53 - 08 : 00 PST PST8PDT &gt; iex&gt; DateTimeParser . parse_datetime ( ~s|&quot;Mar 1, 2018 7:39:53 AM PST&quot;| , to_utc : true ) { :ok , DateTime . from_naive! ( ~N[2018-03-01T15:39:53Z] , &quot;Etc/UTC&quot; ) } iex&gt; { :ok , datetime } = DateTimeParser . parse_datetime ( ~s|&quot;Mar 28, 2018 7:39:53 AM PDT&quot;| ) iex&gt; datetime # DateTime &lt; 2018 - 03 - 28 07 : 39 : 53 - 07 : 00 PDT PST8PDT &gt; iex&gt; DateTimeParser . parse_time ( &quot;10:13pm&quot; ) { :ok , ~T[22:13:00] } iex&gt; DateTimeParser . parse_time ( &quot;10:13:34&quot; ) { :ok , ~T[10:13:34] } iex&gt; DateTimeParser . parse_time ( &quot;18:14:21.145851000000Z&quot; ) { :ok , ~T[18:14:21.145851] } iex&gt; DateTimeParser . parse_datetime ( nil ) { :error , &quot;Could not parse nil&quot; } Installation Add date_time_parser to your list of dependencies in mix.exs : def deps do [ { :date_time_parser , &quot;~&gt; 1.1.4&quot; } ] end Configuration # This is the default config alias DateTimeParser.Parser config :date_time_parser , parsers : [ Parser.Epoch , Parser.Serial , Parser.Tokenizer ] # To enable only specific parsers, include them in the :parsers key. config :date_time_parser , parsers : [ Parser.Tokenizer ] # Or in runtime, pass in the parsers in the function. DateTimeParser . parse ( mystring , parsers : [ Parser.Tokenizer ] ) Write your own parser You can write your own parser! If the built-in parsers are not applicable for your use-case, you may build your own parser to use with this library. Let's write a simple one together. First I will check DateTimeParser.Parser to see what behaviour my new parser should implement. It needs two functions: DateTimeParser.Parser.preflight/1 DateTimeParser.Parser.parse/1 These functions accept the DateTimeParser.Parser.t/0 struct which contains the options supplied by the user, the string itself, and the context for which you should return your result. For example, if the context is :time then you should return a %Time{} ; if :datetime you should return either a %NaiveDateTime{} or a %DateTime{} ; if :date then you should return a %Date{} . Let's implement a parser that reads a special time string. Our string will represent time, but all the digits are shifted up by 10 and must be prefixed with the secret word: &quot;boomshakalaka:&quot; . For example, the real world time of 01:10 is represented as boomshakalaka:11:20 in our toy time format. 12:30 is represented as boomshakalaka:22:40 , and 5:55 is represented as boomshakalaka:15:65 . defmodule MyParser do @behaviour DateTimeParser.Parser @secret_regex ~r|boomshakalaka:(?&lt;time&gt; \\d {2}: \\d {2})| def preflight ( %{ string : string } = parser ) do case Regex . named_captures ( @secret_regex , string ) do %{ &quot;time&quot; =&gt; time } -&gt; { :ok , %{ parser | preflight : time } } nil -&gt; { :error , :not_compatible } end end # ... more below end We'll stop here first and go through the preflight function. Our special parser will only be attempted if the supplied string has any named captures from the regex. That is, it must begin with bookshakalaka: followed by 2 digits, a colon, and 2 more digits. These digits are extracted out like 00:00 where 0 is any digit. If 05:40 is passed in, it would not be compatible so the parser will be skipped. Now let's parse the time: def parse ( %{ preflight : time } = parser ) do [ hour , minute ] = String . split ( time , &quot;:&quot; ) { hour , &quot;&quot; } = Integer . parse ( hour ) { minute , &quot;&quot; } = Integer . parse ( minute ) result = Time . new ( hour - 10 , minute - 10 , 0 , { 0 , 0 } ) for_context ( parser . context , result ) end defp for_context ( :datetime , _result ) , do : :error defp for_context ( :date , _result ) , do : :error defp for_context ( :time , result ) , do : result Notice that we need to consider context of the result. If the user asked for a DateTime, then we need to give them one. In our toy format, it only represents time, so therefore we must return an error when the context is a :datetime or :date . DateTimeParser . parse_time ( &quot;boomshakalaka:11:11&quot; , parsers : [ MyParser ] ) #=&gt; {:ok, ~T[01:01:00]} DateTimeParser . parse_date ( &quot;boomshakalaka:11:11&quot; , parsers : [ MyParser ] ) #=&gt; {:error, &quot;Could not parse \\&quot;boomshakalaka:11:11\\&quot;&quot;} DateTimeParser . parse_datetime ( &quot;boomshakalaka:11:11&quot; , parsers : [ MyParser ] ) #=&gt; {:error, &quot;Could not parse \\&quot;boomshakalaka:11:11\\&quot;&quot;} DateTimeParser . parse ( &quot;boomshakalaka:11:11&quot; , parsers : [ MyParser ] ) #=&gt; {:ok, ~T[01:01:00]} Should I use this library? Only as a last resort. Parsing dates from strings is educated guessing at best. Since Elixir natively supports ISO-8601 parsing (see from_iso8601/2 functions), it's highly recommended that you rely on that first and foremost. When designing your API that involves dates and strings, be specific with your requirements and supported DateTime strings, and preferably only support ISO-8601 with no exceptions. There is no ambiguity with this format so parsing to DateTime (or Date or Time) will always be correct. This library is helpful when you must accept ambiguous DateTime string formats and having incorrect results is acceptable. Do not use this library when the resulting (and possibly incorrect) DateTime has catastrophic and dangerous effects in your system.","ref":"DateTimeParser.html","title":"DateTimeParser","type":"module"},{"doc":"Parse a %DateTime{} , %NaiveDateTime{} , %Date{} , or %Time{} from a string. Accepts parse_options/0","ref":"DateTimeParser.html#parse/2","title":"DateTimeParser.parse/2","type":"function"},{"doc":"Parse a %DateTime{} , %NaiveDateTime{} , %Date{} , or %Time{} from a string. Raises a DateTimeParser.ParseError when parsing fails. Accepts parse_options/0 .","ref":"DateTimeParser.html#parse!/2","title":"DateTimeParser.parse!/2","type":"function"},{"doc":"Parse %Date{} from a string. Accepts options parse_date_options/0","ref":"DateTimeParser.html#parse_date/2","title":"DateTimeParser.parse_date/2","type":"function"},{"doc":"Parse a %Date{} from a string. Raises a DateTimeParser.ParseError when parsing fails. Accepts options parse_date_options/0 .","ref":"DateTimeParser.html#parse_date!/2","title":"DateTimeParser.parse_date!/2","type":"function"},{"doc":"Parse a %DateTime{} or %NaiveDateTime{} from a string. Accepts options parse_datetime_options/0","ref":"DateTimeParser.html#parse_datetime/2","title":"DateTimeParser.parse_datetime/2","type":"function"},{"doc":"Parse a %DateTime{} or %NaiveDateTime{} from a string. Raises a DateTimeParser.ParseError when parsing fails. Accepts options parse_datetime_options/0 .","ref":"DateTimeParser.html#parse_datetime!/2","title":"DateTimeParser.parse_datetime!/2","type":"function"},{"doc":"Parse %Time{} from a string. Accepts options parse_time_options/0","ref":"DateTimeParser.html#parse_time/2","title":"DateTimeParser.parse_time/2","type":"function"},{"doc":"Parse %Time{} from a string. Raises a DateTimeParser.ParseError when parsing fails.","ref":"DateTimeParser.html#parse_time!/2","title":"DateTimeParser.parse_time!/2","type":"function"},{"doc":"","ref":"DateTimeParser.html#t:assume_date/0","title":"DateTimeParser.assume_date/0","type":"type"},{"doc":"","ref":"DateTimeParser.html#t:assume_time/0","title":"DateTimeParser.assume_time/0","type":"type"},{"doc":"","ref":"DateTimeParser.html#t:assume_utc/0","title":"DateTimeParser.assume_utc/0","type":"type"},{"doc":"Options for parse_date/2 :assume_date Default false . If a date cannot be fully determined, then it will not be assumed by default. If you supply true , then Date.utc_today() will be assumed. You can also supply your own date, and the found tokens will be merged with it.","ref":"DateTimeParser.html#t:parse_date_options/0","title":"DateTimeParser.parse_date_options/0","type":"type"},{"doc":"Options for parse_datetime/2 :assume_utc Default false . Only applicable for strings where parsing could not determine a timezone. Instead of returning a NaiveDateTime, this option will assume them to be in UTC timezone, and therefore return a DateTime. If the timezone is determined, then it will continue to be returned in the original timezone. See to_utc option to also convert it to UTC. :to_utc Default false . If there's a timezone detected in the string, then attempt to convert to UTC timezone. If you know that your timestamps are in the future and are going to store it for later use, it may be better to convert to UTC and keep the original timestamp since government organizations may change timezone rules before the timestamp elapses, therefore making the UTC timestamp wrong or invalid. Check out the guide on future timestamps . :assume_time Default false . If a time cannot be determined, then it will not be assumed by default. If you supply true , then ~T[00:00:00] will be assumed. You can also supply your own time, and the found tokens will be merged with it. :use_1904_date_system Default false . For Serial timestamps, the parser will use the 1900 Date System by default. If you supply true , then the 1904 Date System will be used to parse the timestamp. :parsers The parsers to use when analyzing the string. When Parser.Tokenizer , the appropriate tokenizer will be used depending on the function used and conditions found in the string. Order matters and determines the order in which parsers are attempted. These are the available built-in parsers: DateTimeParser.Parser.Epoch DateTimeParser.Parser.Serial DateTimeParser.Parser.Tokenizer DateTimeParser.Parser.DateTime DateTimeParser.Parser.DateTimeUS DateTimeParser.Parser.Date DateTimeParser.Parser.DateUS DateTimeParser.Parser.Time This is the default in this order: DateTimeParser.Parser.Epoch DateTimeParser.Parser.Serial DateTimeParser.Parser.Tokenizer","ref":"DateTimeParser.html#t:parse_datetime_options/0","title":"DateTimeParser.parse_datetime_options/0","type":"type"},{"doc":"Options for parse/2 . Combination of parse_date_options/0 and parse_datetime_options/0 and parse_time_options/0","ref":"DateTimeParser.html#t:parse_options/0","title":"DateTimeParser.parse_options/0","type":"type"},{"doc":"Options for parse_time/2 . See parse_datetime_options/0 for further definition.","ref":"DateTimeParser.html#t:parse_time_options/0","title":"DateTimeParser.parse_time_options/0","type":"type"},{"doc":"List of modules that implement the DateTimeParser.Parser behaviour.","ref":"DateTimeParser.html#t:parsers/0","title":"DateTimeParser.parsers/0","type":"type"},{"doc":"","ref":"DateTimeParser.html#t:to_utc/0","title":"DateTimeParser.to_utc/0","type":"type"},{"doc":"","ref":"DateTimeParser.html#t:use_1904_date_system/0","title":"DateTimeParser.use_1904_date_system/0","type":"type"},{"doc":"Interface for the DateTimeParser to use when parsing a string. The flow is: Preflight the string to see if the parser is appropriate. Sometimes the parsing can happen at this stage if it's a simple parser, for example it can be done in a single regex. Results of the preflight, if needed, can be stored in the struct.preflight . Parse the string. You have context/0 to check if you should return a time, date, or datetime. Also make sure you're honoring the user's options supplied in struct.opts You may create your own parser and use it with the DateTimeParser by creating a module that follows this behaviour.","ref":"DateTimeParser.Parser.html","title":"DateTimeParser.Parser","type":"behaviour"},{"doc":"Parse the string.","ref":"DateTimeParser.Parser.html#c:parse/1","title":"DateTimeParser.Parser.parse/1","type":"callback"},{"doc":"Determine if the string is appropriate to parse with this parser. If not, then other parsers will be attempted.","ref":"DateTimeParser.Parser.html#c:preflight/1","title":"DateTimeParser.Parser.preflight/1","type":"callback"},{"doc":"","ref":"DateTimeParser.Parser.html#t:context/0","title":"DateTimeParser.Parser.context/0","type":"type"},{"doc":"","ref":"DateTimeParser.Parser.html#t:t/0","title":"DateTimeParser.Parser.t/0","type":"type"},{"doc":"Tokenizes the string for date formats. This prioritizes the international standard for representing dates.","ref":"DateTimeParser.Parser.Date.html","title":"DateTimeParser.Parser.Date","type":"module"},{"doc":"Validate either the Date or [Naive]DateTime has a valid day","ref":"DateTimeParser.Parser.Date.html#validate_day/1","title":"DateTimeParser.Parser.Date.validate_day/1","type":"function"},{"doc":"","ref":"DateTimeParser.Parser.Date.html#t:dayable/0","title":"DateTimeParser.Parser.Date.dayable/0","type":"type"},{"doc":"Tokenizes the string for both date and time formats. This prioritizes the international standard for representing dates.","ref":"DateTimeParser.Parser.DateTime.html","title":"DateTimeParser.Parser.DateTime","type":"module"},{"doc":"Convert the given NaiveDateTime to a DateTime if the user provided to_utc: true . If the result is already in UTC, this will pass through.","ref":"DateTimeParser.Parser.DateTime.html#maybe_convert_to_utc/2","title":"DateTimeParser.Parser.DateTime.maybe_convert_to_utc/2","type":"function"},{"doc":"Tokenizes the string for both date and time formats. This prioritizes the US format for representing dates.","ref":"DateTimeParser.Parser.DateTimeUS.html","title":"DateTimeParser.Parser.DateTimeUS","type":"module"},{"doc":"Tokenizes the string for date formats. This prioritizes the US format for representing dates.","ref":"DateTimeParser.Parser.DateUS.html","title":"DateTimeParser.Parser.DateUS","type":"module"},{"doc":"Parses a Unix Epoch timestamp. This is gated by the number of present digits. It must contain 10 or 11 seconds, with an optional subsecond up to 10 digits. Negative epoch timestamps are supported.","ref":"DateTimeParser.Parser.Epoch.html","title":"DateTimeParser.Parser.Epoch","type":"module"},{"doc":"Parses a spreadsheet Serial timestamp. This is gated by the number of present digits. It must contain 1 through 5 digits that represent days, with an optional precision of up to 10 digits that represents time. Negative serial timestamps are supported. Microsoft Excel has, since its earliest versions, incorrectly considered 1900 to be a leap year, and therefore that February 29, 1900 comes between February 28 and March 1 of that year. The bug originated from Lotus 1-2-3 and was purposely implemented in Excel for the purpose of backward compatibility. Microsoft has written an article about this bug, explaining the reasons for treating 1900 as a leap year. This bug has been promoted into a requirement in the Ecma Office Open XML (OOXML) specification. Microsoft Excel on Macintosh defaults to using the 1904 date system. By default, this parser will assume the 1900. If you want to opt-into the 1904 date system, see the t:use_1904_date_system option. See more at https://en.wikipedia.org/wiki/Leap_year_bug","ref":"DateTimeParser.Parser.Serial.html","title":"DateTimeParser.Parser.Serial","type":"module"},{"doc":"Tokenizes the string for time elements. This will also attempt to extract the time out of the string first before tokenizing to reduce noise in an attempt to be more accurate. For example, iex&gt; DateTimeParser . parse_time ( &quot;Hello Johnny 5, it&#39;s 9:30PM&quot; ) { :ok , ~T[21:30:00] } This will use a regex to extract the part of the string that looks like time, ie, &quot;9:30PM&quot;","ref":"DateTimeParser.Parser.Time.html","title":"DateTimeParser.Parser.Time","type":"module"},{"doc":"This parser doesn't parse, instead it checks the string and assigns the appropriate parser during preflight. The appropriate parser is determined by whether there is a &quot;/&quot; present in the string, and if so it will assume the string is a US-formatted date or datetime, and therefore use the US-optimized tokenizer module (ie, DateTimeParser.Parser.DateUS or DateTimeParser.Parser.DateTimeUS ) for them. Time will always be parsed with DateTimeParser.Parser.Time .","ref":"DateTimeParser.Parser.Tokenizer.html","title":"DateTimeParser.Parser.Tokenizer","type":"module"},{"doc":"An error when parsing fails","ref":"DateTimeParser.ParseError.html","title":"DateTimeParser.ParseError","type":"exception"},{"doc":"Future DateTime UTC timestamps If you are certain that all of your timestamps are in the past, then you can safely ignore this guide. If you are working with timestamps that are in the future, and those timestamps are inside countries with governing bodies that have the ability to change timezone rules, including daylight savings, then you may want to consider your timestamp storage strategy. Shortly, it's not foolproof to convert the timestamp to UTC and store only that DateTime.","ref":"future-utc-datetime.html","title":"Future DateTime UTC timestamps","type":"extras"},{"doc":"Consider this scenario: It's currently year 2019 and you receive a timestamp for a user located in Washington, USA for July 4, 2022. You convert it to UTC and store it in your database. Today (in year 2019), Washington state recognizes Daylight Savings Time and it shifts back and forth an hour over the year. Since the timestamp is in the summer, it's shifted forward an hour. In 2020, Washington enacts a new law that declares that they will no longer be participate in Daylight Savings Time; meaning it's always shifted back one hour year-round. You've already stored your timestamps in the future converted to UTC using the old rules. How do you know to fix all your timestamps in your database for users in Washington state?","ref":"future-utc-datetime.html#rules-change","title":"Future DateTime UTC timestamps - Rules Change","type":"extras"},{"doc":"There are 3 elements at play: You need a consistent timestamp field for database queries (opposed to strings). Usually this is UTC timestamps. The user provided a timestamp based on their location, and looked at the clock on their desk when filling in the form in your web app. The provided timestamp is based on the location the user is in, and that location follows a set of rules of how time changes throughout the year. We need to store timestamps in a database column made for timestamps so we can achieve #1. This can be more complicated given your database, but using Postgres as an example, it internally converts to UTC and queries against that. If you're using Ecto as your data mapper, it must always be in UTC before storage. If the law changes between now and the future timestamp, we've lost the correct wall time for the user in #2. When we immediately convert to UTC, we lose the context in #3.","ref":"future-utc-datetime.html#what-is-our-context","title":"Future DateTime UTC timestamps - What is our context?","type":"extras"},{"doc":"Store the user's provided timestamp and timezone separately from the converted UTC. For example: field :my_timestamp_utc , :utc_datetime field :my_timestamp_tz , :string field :my_timestamp_wall , :naive_datetime Since we're making my_timestamp_utc a :utc_datetime , we are affirming we have the timezone information of UTC. Since we're making my_timestamp_wall a :naive_datetime , we're affirming we do not have the timezone. Once you have these 3 pieces of context, you can periodically update and verify changes. It would be good to update your UTC timestamps whenever your tzdata files are updated. If the walltime + timezone is reconverted to UTC and is different from your stored UTC timestamp, then you know the rules have changed since storage. Update the UTC timestamp and perhaps notify the customer to ensure the intentions are still correct (for example, did they already know of the upcoming law change and anticipate it?).","ref":"future-utc-datetime.html#storage-strategy","title":"Future DateTime UTC timestamps - Storage Strategy","type":"extras"},{"doc":"http://www.creativedeletion.com/2015/03/19/persisting_future_datetimes.html","ref":"future-utc-datetime.html#credits","title":"Future DateTime UTC timestamps - Credits","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Update GitHub Repo references","ref":"changelog.html#1-1-4","title":"Changelog - 1.1.4","type":"extras"},{"doc":"Stricter time parsing by requiring time separators. For example, 949 used to be parsed as 09:49:00 , but is now considered not valid. This is to help decrease false positives of nonsensical times such as 25:00 am (incorrectly parsed as 02:05:00 ). Thanks @fcapovilla (PR #46)","ref":"changelog.html#1-1-3","title":"Changelog - 1.1.3","type":"extras"},{"doc":"Correct handling of 12:xx:xx AM timestamps (12hr). These were incorrectly parsed as 12:xx:xx (24hr) timestamps when they should have been 00:xx:xx (24hr) timestamps. Lock Timex to &gt;= 3.2.1 and &lt;= 3.7.2 to avoid timezone conversion issues when using to_utc: true . Looks like there are some breaking changes (for us)","ref":"changelog.html#1-1-2","title":"Changelog - 1.1.2","type":"extras"},{"doc":"Adjust tokenizer to prefer month/day before of day/month when those are the only found tokens. Thanks @mwean raising the issue.","ref":"changelog.html#1-1-1","title":"Changelog - 1.1.1","type":"extras"},{"doc":"Add option use_1904_date_system for the serial parser. It defaults to false . Most spreadsheet applications use the 1900 date system, but Microsoft Excel on Macintosh in particular used the 1904 date system [@fcapovilla].","ref":"changelog.html#1-1-0","title":"Changelog - 1.1.0","type":"extras"},{"doc":"Breaking Change parse_datetime to no longer assume time. Previously, it would assume 00:00:00 if it could not be parsed. This is replaced with an opt-in option assume_time . See next point. If you relied on this, to upgrade add the option; eg: DateTimeParser.parse_datetime(string, assume_time: true) Change parse_datetime to no longer convert DateTime to UTC timezone. If you relied on this, to upgrade add the option; eg: DateTimeParser.parse_datetime(string, to_utc: true) Change parse_date to no longer assume a date. Previously, it would assume the current date, and replace the found information from the string. This is replaced with an opt-in option of assume_date . If you relied on this, to upgrade add the option; eg: DateTimeParser.parse_date(string, assume_date: true) Bugs Fix a UTC conversion bug between Daylight/Standard time (#20). If you're using an earlier version and converting to UTC, please upgrade to &gt;= 1.0.0-rc2 immediately. Fix an epoch subsecond parsing bug (#16) (thanks @tmr08c) Updated for compatibility with Elixir 1.10.0 Features Add parse/2 that will respond with the best match. This function accepts all options introduced below. Change parse_datetime/1 to parse_datetime/2 to accept options: assume_time: true | %Time{} | false with the default of false. Change parse_date/1 to parse_date/2 to accept options: assume_date: true | %Date{} | false with the default of false. Add support for parsing negative epoch times. (#24) (thanks @tmr08c) Add bang variants, parse!/2 , parse_datetime!/2 , parse_time!/2 , and parse_date!/2 Added parsers: [] option to add or disable parsers. This is helpful if you are don't want to consider Serial or Epoch timestamps.","ref":"changelog.html#1-0-0","title":"Changelog - 1.0.0","type":"extras"},{"doc":"Add Serial time support","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"Refactor Support subsecond parsing to 24 digits (yoctoseconds) [thanks @myfreeweb]","ref":"changelog.html#0-1-4","title":"Changelog - 0.1.4","type":"extras"},{"doc":"Support parsing Unix epoch times from strings Fix microsecond parsing","ref":"changelog.html#0-1-3","title":"Changelog - 0.1.3","type":"extras"},{"doc":"Validate days of month. Previously it would allow invalid days such as Feb 30. Now it will check if the year is a leap year and allow up to 29, and otherwise 28 for Feb. It will also reject day 31 on months without 31 days.","ref":"changelog.html#0-1-2","title":"Changelog - 0.1.2","type":"extras"},{"doc":"Fix PM 12-hr conversion. The bug would convert 12:34PM to 24:34 which is not valid","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"},{"doc":"Add DateTimeParser.parse_datetime/2 Add DateTimeParser.parse_date/1 Add DateTimeParser.parse_time/1","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"Examples Input Output (ISO 8601) Method Options 01 Feb 2013 2013-02-01 parse 03 Jan 2013 10:15:26 -0800 2013-01-03T18:15:26Z parse [to_utc: true] 10/1/2018 :: AM 2018-10-01 parse 11 Feb 2013 2013-02-11 parse 11 Jan 2013 13:26:55 -0800 2013-01-11T21:26:55Z parse [to_utc: true] 12/26/2016 2016-12-26 parse 24 Sep 2013 2013-09-24 parse &quot;&quot;=&quot;&quot;9/5/2018&quot;&quot;&quot; 2018-09-05 parse_date &quot;&quot;=&quot;&quot;9/5/2018&quot;&quot;&quot; 2018-09-05T00:00:00 parse_datetime [assume_time: true] &quot;=&quot;&quot;10/1/2018&quot;&quot;&quot; 2018-10-01 parse &quot;=&quot;&quot;9/5/2018&quot;&quot;&quot; 2018-09-05 parse &quot;Apr 1, 2016 12:02:53 AM PDT&quot; 2016-04-01T07:02:53Z parse [to_utc: true] &quot;Apr 1, 2017 2:21:25 AM PDT&quot; 2017-04-01T09:21:25Z parse [to_utc: true] &quot;Dec 1, 2018 7:39:53 AM PST&quot; 2018-12-01T15:39:53Z parse [to_utc: true] &quot;Jan 1, 2013 06:34:31 PM PST&quot; 2013-01-02T02:34:31Z parse [to_utc: true] &quot;Jan 1, 2014 6:44:47 AM PST&quot; 2014-01-01T14:44:47Z parse [to_utc: true] &quot;Mar 28, 2014 6:44:47 AM PDT&quot; 2014-03-28T13:44:47Z parse [to_utc: true] &quot;Nov 16, 2017 9:41:28 PM PST&quot; 2017-11-17T05:41:28Z parse [to_utc: true] &quot;Nov 20, 2016 22:09:23 PM&quot; 2016-11-20T22:09:23 parse &quot;Sat, 29 Sep 2018 21:36:28 -0400&quot; 2018-09-30T01:36:28Z parse [to_utc: true] &quot;September 28, 2016&quot; 2016-09-28 parse &quot;Tuesday, November 29, 2016&quot; 2016-11-29 parse -0000000001 1969-12-31 parse_date -0000000001 1969-12-31T23:59:59Z parse_datetime -0000000001.0000000001 23:59:58.000000 parse_time -0000000001.0000000001 1969-12-31T23:59:58.000000Z parse_datetime -0000000001.000001 23:59:58.999999 parse_time -0000000001.00001 23:59:58.99999 parse_time -0000000001.0001 23:59:58.9999 parse_time -0000000001.001 1969-12-31 parse_date -0000000001.001 23:59:58.999 parse_time -0000000001.01 23:59:58.99 parse_time -0000000001.1 23:59:58.9 parse_time -0000000001.111111 1969-12-31 parse_date -0386380800 1957-10-04T00:00:00Z parse_datetime -363 1899-01-01 parse_date -363.0 1899-01-01T00:00:00 parse_datetime -45103.1454398148 1776-07-04 parse_date -45103.1454398148 20:30:34 parse_time -45103.1454398148 1776-07-04T20:30:34 parse_datetime -9999999999 1653-02-10T06:13:21Z parse_datetime -9999999999.009 1653-02-10 parse_date -9999999999.9 06:13:20.1 parse_time -9999999999.99 06:13:20.01 parse_time -9999999999.999 1653-02-10 parse_date -9999999999.999 06:13:20.001 parse_time -9999999999.9999 06:13:20.0001 parse_time -9999999999.99999 06:13:20.00001 parse_time -9999999999.999999 1653-02-10 parse_date -9999999999.999999 06:13:20.000001 parse_time -9999999999.9999999999 1653-02-10 parse_date -9999999999.9999999999 06:13:20.000001 parse_time -9999999999.9999999999 1653-02-10T06:13:20.000001Z parse_datetime -99999999999 -1199-02-15T14:13:21Z parse_datetime 0000000000 1970-01-01 parse_date 0000000000 00:00:00 parse_time 0000000000 1970-01-01T00:00:00Z parse_datetime 00:00.0 00:00:00 parse_time 01-01-2018 2018-01-01 parse 01-Feb-18 2018-02-01 parse 01-Jul 2019-07-01 parse [assume_date: ~D[2019-01-05]] 01-Jul Could not parse &quot;01-Jul&quot; parse 01-Jul Could not parse &quot;01-Jul&quot; parse_datetime 01-Jul-18 2018-07-01 parse 01.09.2018 2018-09-01 parse 01.11.2018 2018-11-01 parse 01/01/17 2017-01-01 parse 01/01/2017 2017-01-01 parse 01/01/2018 - 17:06 2018-01-01T17:06:00 parse 01/01/2018 01:21PM 2018-01-01T13:21:00 parse 01/01/2018 14:44 2018-01-01T14:44:00 parse 01/01/2018 6:22 2018-01-01T06:22:00 parse 01/02/16 2016-01-02 parse 01/02/18 01:02 AM 2018-01-02T01:02:00 parse 01/02/2015 2015-01-02 parse 01/09/2034 2034-01-09 parse_date 01/09/2034 2034-01-09T00:00:00 parse_datetime [assume_time: true] 01/Jun./2018 2018-06-01 parse 02-05-2018 2018-05-02 parse 02-Oct-17 2017-10-02 parse 02/01/17 2017-02-01 parse 02/01/2018 2018-02-01 parse 02/06/2019 2019-02-06 parse_date 02/06/2019 2019-02-06T00:00:00 parse_datetime [assume_time: true] 02/21/2018 9:37:42 AM 2018-02-21T09:37:42 parse 03/5/2018 2018-03-05 parse 05/01/2018 0:00 2018-05-01T00:00:00 parse 06/14/2018 09:42:08 PM-0500 2018-06-15T02:42:08Z parse [to_utc: true] 06/28/18 1:25 2018-06-28T01:25:00 parse 07:09.3 07:09:00 parse_time 08:53.0 08:53:00 parse_time 1-Apr 2019-04-01 parse [assume_date: ~D[2019-01-13]] 1-Apr Could not parse &quot;1-Apr&quot; parse 1//1/17 2017-01-01 parse 1/1/0117 0117-01-01 parse 1/1/17 19:12 2017-01-01T19:12:00 parse 1/1/18 00:01 2018-01-01T00:01:00 parse 1/1/18 3:24 PM 2018-01-01T15:24:00 parse 1/1/19 10:39 AM 2019-01-01T10:39:00 parse 1/1/2013 2013-01-01 parse 1/10/2018 8:38pM 2018-01-10T20:38:00 parse 1/13/19 2019-01-13 parse_date 1/13/19 2019-01-13T00:00:00 parse_datetime [assume_time: true] 1/13/2019 2019-01-13 parse_date 1/13/2019 2019-01-13T00:00:00 parse_datetime [assume_time: true] 1/15/2019 3:06 2019-01-15 parse_date 1/15/2019 3:06 2019-01-15T03:06:00 parse_datetime 1/17/2018 0:00:00 2018-01-17T00:00:00 parse 1/2/2018 18:06:26 2018-01-02T18:06:26 parse 1/3/2019 12:00:00 AM 2019-01-03T00:00:00 parse 1/31/2018 0:00:00 UTC 2018-01-31T00:00:00Z parse 1/9/2034 2034-01-09 parse_date 1/9/2034 2034-01-09T00:00:00 parse_datetime [assume_time: true] 1/9/34 2034-01-09 parse_date 1/9/34 2034-01-09T00:00:00 parse_datetime [assume_time: true] 10/2/2017 - 23:14 2017-10-02T23:14:00 parse 10/5/2017 23:52 2017-10-05T23:52:00 parse 10:13.7 10:13:00 parse_time 11 July 2017 1:43:46 PM 2017-07-11 parse_date 11 July 2017 1:43:46 PM 2017-07-11T13:43:46 parse_datetime 12/5 2021-12-05 parse_date [assume_date: ~D[2021-01-01]] 13/5 2021-05-13 parse_date [assume_date: ~D[2021-01-01]] 18-07-2018 20:38:34 +00:00 2018-07-18T20:38:34Z parse 18-12-29 2018-12-29 parse 19 September 18 2:33:08 PM 2018-09-19 parse_date 19 September 18 2:33:08 PM 2018-09-19T14:33:08 parse_datetime 19 September 2018 08:15:22 AM 2018-09-19 parse_date 19 September 2018 08:15:22 AM 2018-09-19T08:15:22 parse_datetime 19-Dec-19 2019-12-19 parse 2 1900-01-01 parse_date 2.0 1900-01-01T00:00:00 parse_datetime 2/5 2021-02-05 parse_date [assume_date: ~D[2021-01-01]] 2010/01/01 2010-01-01 parse 2011-01-01 04:19:20 -0:00 2011-01-01T04:19:20Z parse 2012-10-30 09:52:00 2012-10-30T09:52:00 parse 2012-11-23T22:42:25-05:00 2012-11-24T03:42:25Z parse [to_utc: true] 2013-04-26 11:25:03 UTC 2013-04-26T11:25:03Z parse 2013-09-10 22:14:56.717 2013-09-10T22:14:56.717 parse 2013-12-31T22:18:50+00:00 2013-12-31T22:18:50Z parse 2015-09-28 10:57:11 -0700 2015-09-28T17:57:11Z parse [to_utc: true] 2015/12/1 1:16 2015-12-01T01:16:00 parse 2016-02-29 2016-02-29 parse_date 2016-02-29 00:00:00 UTC 2016-02-29T00:00:00Z parse_datetime 2016-04-30 2016-04-30 parse 2016-05-02T01:10:06+00:00 2016-05-02T01:10:06Z parse 2016-06-11 15:50:43 2016-06-11T15:50:43 parse 2016-06-16 06:06:06 2016-06-16T06:06:06 parse 2016-07-01 01:51:34+00 2016-07-01T01:51:34Z parse 2016-07-31 18:42:46-07:00 2016-08-01T01:42:46Z parse [to_utc: true] 2016-08-04T07:00:25Z 2016-08-04T07:00:25Z parse 2016-08-19 09:34:51.0 2016-08-19T09:34:51.0 parse 2016-11-17 10:36:34.81 2016-11-17T10:36:34.81 parse 2016-11-23T16:25:33.971897 2016-11-23T16:25:33.971897 parse 2016/1/9 2016-01-09 parse 2017-02-29 Could not parse &quot;2017-02-29&quot; parse_date 2017-02-29 00:00:00 UTC Could not parse &quot;2017-02-29 00:00:00 UTC&quot; parse_datetime 2017-04-31 Could not parse &quot;2017-04-31&quot; parse_date 2017-04-31 00:00:00 UTC Could not parse &quot;2017-04-31 00:00:00 UTC&quot; parse_datetime 2017-06-31 Could not parse &quot;2017-06-31&quot; parse_date 2017-06-31 00:00:00 UTC Could not parse &quot;2017-06-31 00:00:00 UTC&quot; parse_datetime 2017-09-29+00:00 2017-09-29T00:00:00 parse 2017-09-31 Could not parse &quot;2017-09-31&quot; parse_date 2017-09-31 00:00:00 UTC Could not parse &quot;2017-09-31 00:00:00 UTC&quot; parse_datetime 2017-10-06+03:45:16 2017-10-06T03:45:16 parse 2017-10-24 04:00:10 PDT 2017-10-24T11:00:10Z parse [to_utc: true] 2017-11-04 15:20:47 EDT 2017-11-04 parse_date 2017-11-04 15:20:47 EDT 2017-11-04T19:20:47Z parse_datetime [to_utc: true] 2017-11-04 15:20:47 EST 2017-11-04 parse_date 2017-11-04 15:20:47 EST 2017-11-04T20:20:47Z parse_datetime [to_utc: true] 2017-11-04 15:20:47 UTC 2017-11-04 parse_date 2017-11-04 15:20:47 UTC 2017-11-04T15:20:47Z parse_datetime 2017-11-04 15:20:47+0000 2017-11-04 parse_date 2017-11-04 15:20:47+0000 2017-11-04T15:20:47Z parse_datetime 2017-11-04 15:20:47+0500 2017-11-04 parse_date 2017-11-04 15:20:47+0500 2017-11-04T10:20:47Z parse_datetime [to_utc: true] 2017-11-04 15:20:47-0500 2017-11-04 parse_date 2017-11-04 15:20:47-0500 2017-11-04T20:20:47Z parse_datetime [to_utc: true] 2017-11-31 Could not parse &quot;2017-11-31&quot; parse_date 2017-11-31 00:00:00 UTC Could not parse &quot;2017-11-31 00:00:00 UTC&quot; parse_datetime 2017-12-01 03:52 2017-12-01T03:52:00 parse 2017/08/08 2017-08-08 parse 2019-05-16+04:00 2019-05-16 parse_date 2019-05-16+04:00 2019-05-16T04:00:00 parse_datetime [assume_time: true] 2019-05-20 10:00:00PST 2019-05-20 parse_date 2019-05-20 10:00:00PST 2019-05-20T17:00:00Z parse_datetime [to_utc: true] 2019/01/31 0:01 2019-01-31T00:01:00 parse 2021-03-27 00:00 am 2021-03-27T00:00:00 parse_datetime 2021-03-27 00:00 pm 2021-03-27T00:00:00 parse_datetime 2021-03-27 12:00 am 2021-03-27T00:00:00 parse_datetime 2021-03-27 12:00 pm 2021-03-27T12:00:00 parse_datetime 2034-01-13 2034-01-13 parse_date 2034-01-13 2034-01-13T00:00:00 parse_datetime [assume_time: true] 2034-1-9 2034-01-09 parse_date 2034-1-9 2034-01-09T00:00:00 parse_datetime [assume_time: true] 20340109 2034-01-09T00:00:00 parse_datetime [assume_time: true] 23-05-2019 @ 10:01 2019-05-23 parse_date 23-05-2019 @ 10:01 2019-05-23T10:01:00 parse_datetime [assume_time: true] 29/Aug./2018 2018-08-29 parse 29/Sep./2018 2018-09-29 parse 34-1-13 2034-01-13 parse_date 34-1-13 2034-01-13T00:00:00 parse_datetime [assume_time: true] 4/24/2019 0:00:00 2019-04-24 parse_date 4/24/2019 0:00:00 2019-04-24T00:00:00 parse_datetime 41261.6013888889 2012-12-18 parse_date 41261.6013888889 14:26:00 parse_time 41261.6013888889 2012-12-18T14:26:00 parse_datetime 5/12/2019 12:21:58 PM 2019-05-12T12:21:58 parse 5/2/2019 0:00:00 2019-05-02 parse_date 5/2/2019 0:00:00 2019-05-02T00:00:00 parse_datetime 5/2/2019 12:00:00 AM 2019-05-02 parse_date 5/2/2019 12:00:00 AM 2019-05-02T00:00:00 parse_datetime 5/31/2019 12:00:00 AM 2019-05-31 parse_date 5/31/2019 12:00:00 AM 2019-05-31T00:00:00 parse_datetime 62 1900-03-02 parse_date 62 1900-03-02T00:00:00 parse [assume_time: true] 62 1904-03-03T00:00:00 parse [assume_time: true, use_1904_date_system: true] 62.0 1900-03-02T00:00:00 parse 62.0 1900-03-02T00:00:00 parse_datetime 62.0 1904-03-03T00:00:00 parse [use_1904_date_system: true] 62.0 1904-03-03T00:00:00 parse_datetime [use_1904_date_system: true] 9-2-32 2032-02-09 parse_date 9-2-32 2032-02-09T00:00:00 parse_datetime [assume_time: true] 9-Feb-18 2018-02-09 parse_date 9-Feb-18 2018-02-09T00:00:00 parse_datetime [assume_time: true] 9/1/2018 10:26 2018-09-01 parse_date 9/1/2018 10:26 2018-09-01T10:26:00 parse_datetime [assume_time: true] 9/10/2018 11:08:13 AM 2018-09-10T11:08:13 parse 9/19/2018 20:38 2018-09-19T20:38:00 parse 9/20/2017 18:57:24 UTC 2017-09-20T18:57:24Z parse 9/4/2018 0:00 2018-09-04 parse_date 9/4/2018 0:00 2018-09-04T00:00:00 parse_datetime 9999999999 2286-11-20 parse_date 9999999999 17:46:39 parse_time 9999999999 2286-11-20T17:46:39Z parse_datetime 9999999999.0000000009 2286-11-20T17:46:39.000000Z parse_datetime 9999999999.0000009000 2286-11-20T17:46:39.000000Z parse_datetime 9999999999.000001 17:46:39.000001 parse_time 9999999999.000010 17:46:39.000010 parse_time 9999999999.000100 17:46:39.000100 parse_time 9999999999.001000 17:46:39.001000 parse_time 9999999999.009 2286-11-20 parse_date 9999999999.009 17:46:39.009 parse_time 9999999999.009 2286-11-20T17:46:39.009Z parse_datetime 9999999999.010000 17:46:39.010000 parse_time 9999999999.090 2286-11-20T17:46:39.090Z parse_datetime 9999999999.100000 17:46:39.100000 parse_time 9999999999.900 17:46:39.900 parse_time 9999999999.900 2286-11-20T17:46:39.900Z parse_datetime 9999999999.999 2286-11-20 parse_date 9999999999.999 17:46:39.999 parse_time 9999999999.999 2286-11-20T17:46:39.999Z parse_datetime 9999999999.999999 2286-11-20 parse_date 9999999999.999999 17:46:39.999999 parse_time 9999999999.999999 2286-11-20T17:46:39.999999Z parse_datetime 9999999999.9999999999 2286-11-20 parse_date 9999999999.9999999999 17:46:39.999999 parse_time 9999999999.9999999999 2286-11-20T17:46:39.999999Z parse_datetime 99999999999 5138-11-16 parse_date 99999999999 09:46:39 parse_time 99999999999 5138-11-16T09:46:39Z parse_datetime Fri Mar 2 09:01:57 2018 2018-03-02T09:01:57 parse Fri Mar 31 2017 21:41:40 GMT+0000 (UTC) 2017-03-31T21:41:40Z parse Friday 02 February 2018 10:42:21 AM 2018-02-02T10:42:21 parse Jan-01-19 2019-01-01 parse Jan-01-19 2019-01-01T00:00:00 parse [assume_time: true] Jan-01-19 2019-01-01T10:13:15 parse [assume_time: ~T[10:13:15]] Jan-01-2018 2018-01-01 parse May 30, 2019 4:31:09 AM PDT 2019-05-30 parse_date May 30, 2019 4:31:09 AM PDT 2019-05-30T11:31:09Z parse_datetime [to_utc: true] Monday 01 October 2018 06:34:19 AM 2018-10-01T06:34:19 parse Monday 02 October 2017 9:04:49 AM 2017-10-02T09:04:49 parse November 29, 2016 2016-11-29 parse_date November 29, 2016 2016-11-29T00:00:00 parse_datetime [assume_time: true] Oct 5, 2018 6:16:56 PM PDT 2018-10-05 parse_date Oct 5, 2018 6:16:56 PM PDT 2018-10-06T01:16:56Z parse_datetime [to_utc: true] Sep-19-16 2016-09-19 parse_date Sep-19-16 2016-09-19T00:00:00 parse_datetime [assume_time: true] Sun 01 January 2017 10:11:02 PM 2017-01-01 parse_date Sun 01 January 2017 10:11:02 PM 2017-01-01T22:11:02 parse_datetime Sun Jan 08 2017 04:28:42 GMT+0000 (UTC) 2017-01-08T04:28:42Z parse Sun Jul 1 00:31:18 2018 2018-07-01T00:31:18 parse Sun, 01 January 2017 10:11:02 PM 2017-01-01 parse_date Sun, 01 January 2017 10:11:02 PM 2017-01-01T22:11:02 parse_datetime Sunday 01 January 2017 09:22:46 AM 2017-01-01T09:22:46 parse Sunday 01 January 2017 10:11:02 PM 2017-01-01 parse_date Sunday 01 January 2017 10:11:02 PM 2017-01-01T22:11:02 parse_datetime Sunday 01 January 2017 10:11:02 PM 2017-01-01T22:11:02 parse Sunday, 01 January 2017 10:11:02 PM 2017-01-01 parse_date Sunday, 01 January 2017 10:11:02 PM 2017-01-01T22:11:02 parse_datetime Thu Aug 09 2018 17:13:43 GMT+0000 (UTC) 2018-08-09T17:13:43Z parse Thu Feb 08 00:24:33 2018 2018-02-08T00:24:33 parse Thu Jul 5 12:19:56 2018 2018-07-05T12:19:56 parse Thursday 30 August 2018 11:31:18 AM 2018-08-30T11:31:18 parse Tue Jul 31 06:44:39 2018 2018-07-31T06:44:39 parse Tuesday 11 July 2017 1:43:46 PM 2017-07-11T13:43:46 parse jul-10-18 2018-07-10 parse","ref":"examples.html","title":"Examples","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2018 David Bernheisel Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]